<?php
namespace Financeiro\Logic\ContasReceber\Boleto\AssociarBoleto;

use \Financeiro\Logic\ContasReceber\Boleto\AssociarBoleto\ExcecaoAssociar;
use \Financeiro\Entities\Boletreceber;
use \Financeiro\Entities\Contareceber;
use \Geral\Entities\Tipoctreceber;
use \Financeiro\Logic\ContasReceber\Boleto\Exception;
use \Financeiro\Logic\ContasReceber\Boleto\Exception\ExcecaoCnab;
use \Geral\Entities\Endeclie;
use \Geral\Entities\Cliente;
use \Financeiro\Entities\Tprecboleto;
use \OrcamentoEventos\Entities\Nfrelacorc;
use \Fiscal\Entities\Notafiscal;
use Geral\Entities\Paramgeral;


/**
 * Created by JetBrains PhpStorm.
 * User: alanoliveira
 * Date: 11/06/13
 * Time: 11:08
 * To change this template use File | Settings | File Templates.
 */
class ValidacaoAssociar
{
   public static function ValidaAssociacao($boletos)
   {
       $licensaUso  = null;
       $nrorcaevento = null;
       $idtipodeconta = null;


       foreach ($boletos as $linha){

           /** @var $boleto Boletreceber */
           $boleto = Boletreceber::findOneByNrorgAndCdfilialAndNrlanbolrec($linha['NRORG'], $linha['CDFILIAL'],$linha['NRLANBOLREC']);

           //Verifica se clientes possuem licença de uso diferentes
           if ((bool)$licensaUso === false){
              $licensaUso = $boleto->getCdCliente().$boleto->getNrlicencauso();
           }

           $teste = $boleto->getCdCliente().$boleto->getNrlicencauso();
           if($licensaUso != ($boleto->getCdCliente().$boleto->getNrlicencauso())){
               ExcecaoAssociar::cliente_Dif();
           }

           //Verifica se há boletos com contas de tipo diferente (normal/adiantamento)
           //marcados para associação.
           /** @var $conta ContaReceber */
           $conta = Contareceber::findOneByCdfilibolrecAndNrlanbolrecAndNrorg($linha['CDFILIAL'],$linha['NRLANBOLREC'],$linha['NRORG']);
           /** @var $tipodeconta Tipoctreceber */
           $tipodeconta = Tipoctreceber::findOneByCdtpctrecebAndNrorg($conta->getCdtpctreceb(),$conta->getNrorg());

           if ((bool)$idtipodeconta === false){
               $idtipodeconta = $tipodeconta->getIdtpctreceber();
           }

           if($idtipodeconta != $tipodeconta->getIdtpctreceber()){
               ExcecaoAssociar::tipo_conta_dif_bol();
           }

           //Verifica se o boleto foi emitido
           if($boleto->getIdstatbrec() == 'E'){
               ExcecaoAssociar::boleto_emit();
           }

           //Verifica se o boleto foi enviado via CNAB
           if (!in_array($boleto->getIdsitucnabr(),array('00','01'))){
               ExcecaoCnab::Cnab_N_Alterado();
           }

           //Verifica se o boleto foi protestado
           if($boleto->getIdprotestrec() == 'S'){
               ExcecaoAssociar::bol_protestado();
           }

           //Verifica boleto parcelado

           if ((bool)$boleto->getCdmotiparc() === true){
               ExcecaoAssociar::bol_parc_n_ass();
           }

          // Verifica boletos com orçamento distinto
           /** @var $paramgeral ParamGeral */
           $paramgeral = Paramgeral::findOneByNrorg($linha['NRORG']);
           if ($paramgeral->getIdexibdadorc() == 'S')
           {
               //Busca Nota Fiscal da Conta Corrente
               /** @var $notafiscal NotaFiscal */
               $notafiscal = Notafiscal::findOneByCdfilialAndNrlanctonfAndNrorg($conta->getCdfilial(),$conta->getNrlanctonf(),$conta->getNrorg());


               //Busca tabela Nfrelacorc que pode conter orçamento
               /** @var $nfrelacorc Nfrelacorc */
               $nfrelacorc = Nfrelacorc::findOneByCdfilialnfAndNrlanctonfAndNrorg
                                        ($notafiscal->getCdfilial(),$notafiscal->getNrlanctonf(),$notafiscal->getNrorg());

               if ((bool)$nfrelacorc === true){
                   if (((bool)$nrorcaevento === false)){
                      $nrorcaevento = $nfrelacorc->getNrorcaevento();
                   }

                   if (((bool)$nfrelacorc->getNrorcaevento() === true)){
                       if ($nrorcaevento != $nfrelacorc->getNrorcaevento())
                       {
                          ExcecaoAssociar::orca_dif();
                       }

                   }
               }

           }

       }
   }

}
