<?php
namespace Folha\Repositories;


class GpeVinculom extends \Doctrine\ORM\EntityRepository
{
    public static function buscaEstruturaLegal($nrorg, $params)
    {
        $where = "NRORG = $nrorg";
        
        switch ($params['ORDEM']){
            case 'MATRICULA':{
                $where .= " AND CDMATRICULA BETWEEN {$params['NOME_INICIO']} AND {$params['NOME_FINAL']} AND DTRESCISAOVINC > '01/01/{$params['ANO']}' AND DTADMISSAOVINC < '31/12/{$params['ANO']}'";
                break;
            }
            case 'ALFABETICA':{
                if($params['NOME_INICIO'] < $params['NOME_FINAL'])
                    $where .= " AND NMVINCULOM BETWEEN '{$params['NOME_INICIO']}' AND '{$params['NOME_FINAL']}' AND (DTRESCISAOVINC > '01/01/{$params['ANO']}' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC < '31/12/{$params['ANO']}'";
                elseif($params['NOME_INICIO'] > $params['NOME_FINAL'])
                    $where .= " AND NMVINCULOM BETWEEN '{$params['NOME_FINAL']}' AND '{$params['NOME_INICIO']}' AND (DTRESCISAOVINC > '01/01/{$params['ANO']}' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC < '31/12/{$params['ANO']}'";
                else
                    $where .= " AND NMVINCULOM = '{$params['NOME_FINAL']}' AND (DTRESCISAOVINC > '01/01/{$params['ANO']}' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC < '31/12/{$params['ANO']}'";
                break;
            }
            case 'DATA_ADMISSAO':{
                $where.= " AND DTADMISSAOVINC BETWEEN {$params['DTADMISSAO_INI']} AND {$params['DTADMISSAO_FIM']} AND (DTRESCISAOVINC > '01/01/{$params['ANO']}' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC < '31/12/{$params['ANO']}'";
                break;
            }
        }

        $sql = 'SELECT NRESTRUTLEGAL,
                    NRORG,
                    NRVINCULOM
                FROM (SELECT GPE_VINCULOM.NRVINCULOM,
                          GPE_VINCULOM.NMVINCULOM,
                          GPE_VINCULOM.CDMATRICULA,
                          GPE_VINCULOM.DTADMISSAOVINC,
                          GPE_VINCULOM.DTRESCISAOVINC,
                          GPE_VINCULOH.NRESTRUTLEGAL,
                          GPE_VINCULOH.NRORG
                      FROM GPE_VINCULOM
                      INNER JOIN GPE_VINCULOH
                          ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                          AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                      INNER JOIN (SELECT MAX(GPE_VINCULOH.DTMESCOMPETENC) DTMESCOMPETENC,
                                      GPE_VINCULOH.NRVINCULOM,
                                      GPE_VINCULOH.NRORG
                                  FROM GPE_VINCULOH
                                  GROUP BY GPE_VINCULOH.NRVINCULOM,
                                      GPE_VINCULOH.NRORG
                          )MAX_HISTORICO
                          ON MAX_HISTORICO.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                          AND MAX_HISTORICO.DTMESCOMPETENC = GPE_VINCULOH.DTMESCOMPETENC
                          AND MAX_HISTORICO.NRORG = GPE_VINCULOH.NRORG
                    )GPE_VINCULOM
                    WHERE '.$where;

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return ($result) ? $result : false;

    }

    public static function getVinculosPorSelecao($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrOrgPadrao, $nrOrg)
    {
        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
           $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
            $sql = "SELECT VCM.NRVINCULOM
                      FROM GPE_TIPOVINCULOM TVM,
                           GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                     WHERE (($criterio BETWEEN '$inicio' AND '$fim')
                        OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                       AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                       AND VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                  ORDER BY VCM.NMVINCULOM";
        } else {
            $sql = "SELECT VCM.NRVINCULOM
                      FROM GPE_TIPOVINCULOM TVM,
                           GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                     WHERE VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND TO_CHAR(VIH.DTMESCOMPETENC,'DD/MM/YYYY') <= '$dtCompetencia')
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                  ORDER BY VCM.NMVINCULOM";
        }

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return (count($result) > 0) ? $result : false;
    }

    public static function getVinculosPorSelecaoNRescindidos($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrOrgPadrao, $nrOrg)
    {
        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
            $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
            $sql = "SELECT VCM.NRVINCULOM,
                           VCM.NMVINCULOM
                      FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                     WHERE (($criterio BETWEEN '$inicio' AND '$fim')
                        OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                            AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                       AND VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$dtCompetencia', 'DD/MM/YYYY')
                                                 )
                       AND (VCM.DTRESCISAOVINC IS NULL OR VCM.DTRESCISAOVINC > TO_DATE('$dtCompetencia', 'DD/MM/YYYY'))
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        } else {
            $sql = "SELECT VCM.NRVINCULOM,
                           VCM.NMVINCULOM
                      FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                     WHERE VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$dtCompetencia', 'DD/MM/YYYY')
                                                 )
                       AND (VCM.DTRESCISAOVINC IS NULL OR VCM.DTRESCISAOVINC > TO_DATE('$dtCompetencia', 'DD/MM/YYYY'))
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        }

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return (count($result) > 0) ? $result : false;
    }
}